<?php
/**
 * Aheadworks Inc.
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the EULA
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * https://ecommerce.aheadworks.com/end-user-license-agreement/
 *
 * @package    Followupemail2
 * @version    2.2.3
 * @copyright  Copyright (c) 2020 Aheadworks Inc. (http://www.aheadworks.com)
 * @license    https://ecommerce.aheadworks.com/end-user-license-agreement/
 */
namespace Aheadworks\Followupemail2\Model\ResourceModel\Email\Relation\Statistics;

use Aheadworks\Followupemail2\Api\StatisticsManagementInterface;
use Magento\Framework\EntityManager\Operation\ExtensionInterface;

/**
 * Class DeleteHandler
 * @package Aheadworks\Followupemail2\Model\ResourceModel\Email\Relation\Statistics
 * @codeCoverageIgnore
 */
class DeleteHandler implements ExtensionInterface
{
    /**
     * @var StatisticsManagementInterface
     */
    private $statisticsManagement;

    /**
     * @param StatisticsManagementInterface $statisticsManagement
     */
    public function __construct(
        StatisticsManagementInterface $statisticsManagement
    ) {
        $this->statisticsManagement = $statisticsManagement;
    }

    /**
     * {@inheritdoc}
     * @SuppressWarnings(PHPMD.UnusedFormalParameter)
     */
    public function execute($entity, $arguments = [])
    {
        $entityId = (int)$entity->getId();
        $this->statisticsManagement->updateByEmailId($entityId);

        return $entity;
    }
}
